use Config;
use Cwd;
use ExtUtils::Installed;

my @needed_module = qw/ Net::Telnet Tk /;

print "checking required modules\n";
my @modules = ExtUtils::Installed->new()->modules();
my $ok = 1;
foreach my $m( @needed_module )
{
	print "looking for module $m... ";
	print( ($ok*=grep $m, @modules )? "found\n":"not found\n");
}
print "modules are missing, ymusk will probably not work\n" unless $ok;

print "looking for module Tk::FontDialog... ";
print( (grep 'Tk::FontDialog', @modules )? "found\n":"not found -- oh well, no biggie\n");

print "looking for module Chatbot::Eliza... ";
print ( (grep 'Chatbot::Eliza', @modules )? "found\n":"not found -- oh well, no biggie\n");

my $pwd = cwd;
print "we are in $pwd\n";

print "looking where perl is... ";
my $fullperl = $Config{ 'perlpath' };
print "perl is $fullperl\n";

print "updating shebang line of ymusk and friends\n";
for( 'ymusk' )
{
	print "updating shebang line of $_... ";
	update_command_line( $_ );
	print "done\n";
}

print "making ymusk executable... ";
chmod 0755, 'ymusk' or die "can't make ymusk executable: $!\n";
print "done\n";


print "installation complete, ymusk is ready to rock\n";


sub update_command_line
{
	my $file = shift;
	open FILE, $file or die "can't open file $file: $!\n";
	my @lines = <FILE>;
	shift @lines if $lines[0] =~ /^#!/;
	unshift @lines, "#!$fullperl -I$pwd -s\n";
	close FILE;
	open FILE, ">$file" or die "can't open file $file: $!\n";
	print FILE @lines;
	close FILE;
}
